/*****************************************************************************
 * yahoochat.c
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * Copyright (C) 2000 Chris Pinkham
 * Released under the terms of the GPL.
 * *NO WARRANTY*
 *
 * cpinkham@infi.net
 * http://www4.infi.net/~cpinkham/gyach/
 *****************************************************************************/

#include "yahoochat.h"

#include "nix.h"

#include "gyach.h"
#include "commands.h"

extern SESSION *GlobalSessionHook;
int sendYahooPacket(SESSION *sess, u_char *bufp, u_char *endp, char *info);

char *yahoo_status[] = {
	"Here",
	"Be Right Back",
	"Busy",
	"Not at home",
	"Not at my desk",
	"Not in the Office",
	"On the phone",
	"On vacation",
	"Out to lunch",
	"Stepped out",
	"" };


u_char *create_yahoo_header( u_char *buf, u_long pkt_type ) {
	u_char *ptr;

	/* first 4 bytes are "YCHT" */
	strcpy( buf, "YCHT" );

	/* 2nd 4 bytes are long 0x100 */
	ptr = buf + 4;
	*((u_long *)ptr) = htonl( 0x100 );

	/* 3rd 4 bytes are long packet type */
	ptr += 4;
	*((u_long *)ptr) = htonl( pkt_type );

	/* 4th 4 bytes are packet length which is set when we send */

	/* return pointer to right after where length value will be */
	return( buf + 16 );
}

u_char *append_str( u_char *ptr, u_char *str ) {
	while( *str )
		*(ptr++) = *(str++);

	return( ptr );
}

void send_yahoo_text_command( char *cmd, char *txt ) {
	u_char buf[4096];
	u_char *ptr = create_yahoo_header( buf, PKT_OUT_TEXT );

	ptr = append_str( ptr, (u_char *)cmd );
	ptr = append_str( ptr, (u_char *)txt );

	if (( my_status ) &&
		( ! strstr( cmd, "away " ))) {
		if (( ! strstr( cmd, "tell " )) ||
			( pm_brings_back ))
			cmd_away( "0" );
	} 

	send_yahoo_packet( buf, ptr );
}

void send_yahoo_packet( u_char *buf, u_char *end ) {
	/* fixme, replace with lib sometime */
	sendYahooPacket( GlobalSessionHook, buf, end, "send" );
}

